SystemOrganization addCategory: #'ROS-Core'!
SystemOrganization addCategory: #'ROS-TCPROS'!
SystemOrganization addCategory: #'ROS-TCPROS-Tests'!

Object subclass: #TCPROSClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROS-TCPROS'!

Object subclass: #TCPROSHeader
	instanceVariableNames: 'data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROS-TCPROS'!

!TCPROSHeader methodsFor: 'initialize-release' stamp: 'SergeStinckwich 5/27/2012 17:34'!
at:aKey

^ data at:aKey! !

!TCPROSHeader methodsFor: 'initialize-release' stamp: 'SergeStinckwich 5/27/2012 17:59'!
at: aKey put: aValue

(aKey isString and: (aValue isString)) ifTrue:[
data at:aKey put: aValue]
ifFalse:[self error:'header key and value must be string']! !

!TCPROSHeader methodsFor: 'initialize-release' stamp: 'SergeStinckwich 5/27/2012 22:43'!
deserialize: aBinaryArray 
! !

!TCPROSHeader methodsFor: 'initialize-release' stamp: 'SergeStinckwich 5/27/2012 17:39'!
initialize 

data := Dictionary new
! !

!TCPROSHeader methodsFor: 'initialize-release' stamp: 'SergeStinckwich 5/27/2012 22:38'!
serialize 

| bytes |
bytes := #[].

data keysAndValuesDo: [:key :value| |s| 
	s := key, '=', value.
	bytes := bytes, (s size as32bitsUnsignedLittleEndian), s asByteArray.
	].
bytes := bytes size as32bitsUnsignedLittleEndian, bytes.
^ bytes! !

Object subclass: #TCPROSMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROS-TCPROS'!

!TCPROSMessage methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 5/25/2012 17:46'!
protocol
	^#TCPROS! !

!TCPROSMessage methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 5/25/2012 17:47'!
readAllFrom:aSocket! !

!TCPROSMessage methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 5/25/2012 17:47'!
readHeaderFrom:aSocket! !

!TCPROSMessage methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 5/25/2012 17:46'!
write:aMsg on:aSocket! !

!TCPROSMessage methodsFor: 'as yet unclassified' stamp: 'SergeStinckwich 5/25/2012 17:47'!
writeHeaderFrom:aSocket! !

Object subclass: #TCPROSServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROS-TCPROS'!

!Integer methodsFor: '*ROS' stamp: 'SergeStinckwich 5/27/2012 22:32'!
as32bitsUnsignedLittleEndian
	| bytes | 
	bytes := ByteArray new: 4.
	self > 0
		ifTrue: [bytes
				at: 4
				put: (self bitShift: -24)]
		ifFalse: [bytes at: 4 put: ((self bitShift: -24) negated)].
	bytes at: 1 put: self \\ 256.
	bytes at: 2 put: (self bitShift: -8)
			\\ 256.
	bytes at: 3 put: (self bitShift: -16)
			\\ 256.
	^ bytes! !

TestCase subclass: #TCPROSHeaderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ROS-TCPROS-Tests'!

!TCPROSHeaderTest methodsFor: 'tests' stamp: 'SergeStinckwich 5/27/2012 22:43'!
testDeserializeHeader

| h |
h := TCPROSHeader new.
h deserialize: #[8 0 0 0 4 0 0 0 97 97 61 53].
self assert: (h at:'aa' = 5)! !

!TCPROSHeaderTest methodsFor: 'tests' stamp: 'SergeStinckwich 5/27/2012 18:09'!
testHeaderKeysAndValuesAreString

| h |
h := TCPROSHeader new.

self shouldnt: [h at: 'aa' put: '5'] raise: Error.
self should: [h at: 1 put: 2] raise: Error! !

!TCPROSHeaderTest methodsFor: 'tests' stamp: 'SergeStinckwich 5/27/2012 18:10'!
testHeaderWorksAsADictionnary

| h |
h := TCPROSHeader new.
h at: 'aa' put: '5'.

self assert: (h at:'aa') equals:'5'! !

!TCPROSHeaderTest methodsFor: 'tests' stamp: 'SergeStinckwich 5/27/2012 22:39'!
testSerializeHeader

| h |
h := TCPROSHeader new.
h at: 'aa' put: '5'.

self assert: (h serialize = #[8 0 0 0 4 0 0 0 97 97 61 53])! !
